! *****************************************************************
!
! This file contains the Fortran 90 program that runs the numerical 
! model, and compares numerical results with the analytic solution
!
! Copyright (C) 2009 David McInerney, University of Chicago
!
! *****************************************************************
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program (see file "COPYING").  If not, see
!    <http://www.gnu.org/licenses/>.
!
! *****************************************************************

program main
  
! *****************************************************************

  use analytic, only : setup_analytic
  use check_module, only : check
  use numerical, only : setup_numerical, run_numerical
  use parameters, only : print_parameters, h0, Cl
  use output_module, only : dirname

  implicit none

! Test 1
!  print*,"Test 1"
!  dirname = "../Output/Test1/28_20_2000"
!  dirname = "../Output/Test1/56_40_8000"
!  dirname = "../Output/Test1/140_100_50000"
!  h0 = 1d0 ! depth of lake
!  Cl = 0.00075d0 ! linear fric coeff
    
! Test 2
!  print*,"Test 2"
!  dirname = "../Output/Test2/28_20_2000"
!  dirname = "../Output/Test2/56_40_8000"
!  dirname = "../Output/Test2/140_100_50000"
!  h0 = 2d0 ! depth of lake
!  Cl = 0.00046d0 ! linear fric coeff

! Test 3
  print*,"Test 3"
!  dirname = "../Output/Test3/28_20_2000"
!  dirname = "../Output/Test3/56_40_8000"
  dirname = "../Output/Test3/140_100_50000"
  h0 = 5d0 ! depth of lake
  Cl = 0.000145d0 ! linear fric coeff

  print*,"Output directory = ",dirname

! print parameters
  call print_parameters

! setup numerical solution
  call setup_numerical

! setup analytic solution
  call setup_analytic

! check to see if assumptions are satisfied
!  call check
!   stop

  call run_numerical

end program main

